#!/bin/sh
# chrono_activite.tcl du projet mulot.tcl
# \
exec wish "$0" ${1+"$@"}

#*************************************************************************
#  Copyright (C) 2002 Eric Seigne <erics@rycks.com>
# 
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
# 
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
# 
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# 
#**************************************************************************
#  File  : $Id: chrono_activite.tcl,v 1.3 2005/03/21 08:38:25 abuledu_andre Exp $
#  Author  : andre.connes@toulouse.iufm.fr
#  Date    : 10/07/2003 Modification : 06/12/2004
#  Licence : GNU/GPL Version 2 ou plus
# 
#  Description:
#  ------------
# 
#  @version    
#  @author     Andre Connes
#  @modifier   
#  @project    Le terrier
#  @copyright  Eric Seigne 24/04/2002
# 
#  *************************************************************************

source mulot.conf
source msg.tcl
source eval.tcl

  #
  # langue par dfaut
  #
  set f [open [file join $glob(home_reglages) lang.conf] "r"]
  gets $f lang
  close $f
  ::msgcat::mclocale $lang
  ::msgcat::mcload [file join [file dirname [info script]] msgs]

if { $glob(platform) == "windows" } {
  set f [open [file join $glob(home_mulot) reglages trace_user] "r"]
  set glob(trace_user) [gets $f]
  close $f
}

#charger la liste des images
  set f [open [file join $glob(home_mulot) reglages dir_images.conf] "r"]
  set glob(chrono) [gets $f]

  set tmp_im_liste [glob [file join images $glob(chrono) *.*]]
  set glob(n_im_liste) [llength $tmp_im_liste]

# facteur de rduction des vignettes
set glob(reduction) 4

set ecart 10
# modifier les dimensions de la fentre  cause du nombre de vignettes
set glob(height) [expr 2*400/$glob(reduction)+30+3]
set glob(width) [expr $glob(n_im_liste)*600/$glob(reduction)+$glob(n_im_liste)*$ecart]

# dimension des vignettes
set glob(v_height) [expr 400/$glob(reduction)]
set glob(v_width)  [expr 600/$glob(reduction)]

########################### On cre la fentre principale###########################

# placement de la fentre en haut et  gauche de l'cran

. configure -bg $glob(bgcolor)
wm geometry . +0+0

frame .frame -width $glob(width) -height $glob(height) -bg $glob(bgcolor)
pack .frame -side top -fill both -expand yes


# #######################On cre un canvas###########################################
# charg d'accueillir les sorties graphiques,
# qui peuvent tre des images, des textes, des formes gomtriques ...

set c .frame.c
canvas $c -width $glob(width) -height $glob(height) -bg $glob(bgcolor) -highlightbackground $glob(bgcolor)
pack $c -expand true 

################################################

proc lanceappli_withdraw {appli {niveau 0}} {
	destroy .
	set appli [file join $appli]
	exec wish $appli $niveau &
}

# ##
# sauver trace-lve et parcours
# ##

proc sauver_trace_parcours {} {
  global glob heure_debut
  #
  # trace
  # utilisateur/classe/date/dure/didacticiel/nvignettes/version
  set eleve $glob(trace_user)
  set titre "mulot-$glob(version)"
  set categorie "Chronologie"
  if { $glob(platform) == "unix" } {
    set heure_fin [clock clicks -milliseconds]
    set duree [expr abs(int($heure_debut-$heure_fin)/1000)]
    set date_heure [clock format [clock seconds] -format "%c"]
    set quoi "classe \{$date_heure\} $duree"
  } else {
    set quoi "classe \{Ddd Mmm 99 00:00:00 9999\} 0"
  }

  enregistreval $titre $categorie $quoi $eleve

}

# #################################################################################
# frame en bas avec boutons 'continuer', flches gauche et droite, le score et une tiquette de controle de la rponse

frame .bframe -bg $glob(bgcolor)
pack .bframe -side bottom -expand true
label .bframe.lab2 -bg $glob(bgcolor) -font 12x24
grid .bframe.lab2 -column 1 -padx 20 -row 1

label .bframe.lab3 -bg $glob(bgcolor) -font 12x24
grid .bframe.lab3 -column 5 -padx 20 -row 1

button .bframe.but_quitter -image \
	[image create photo fquitter -file [file join sysdata quitter_minus.gif]] \
	-command exit
grid .bframe.but_quitter -column 6  -row 1

#
proc melanger_im_liste {} {
#
  global glob
  #
  # secouer 5 fois
  #
  for { set i 0} {$i < 5} {incr i} {
    set a [expr int(rand()*$glob(n_im_liste))+1]
    set b [expr int(rand()*$glob(n_im_liste))+1]
    set tmp $glob(n_im_$a)
    set glob(n_im_$a) $glob(n_im_$b)
    set glob(n_im_$b) $tmp
  }
} ;# melanger_im_liste

# ####################### proc main_loop ########################
proc main_loop {c} {
  global glob nv im_choix heure_debut v_placees ecart tmp_im_liste
  # nv = numro de vignette
  # v_placees = nombre de vignettes places

  $c delete all
  set v_placees 0

  .bframe.lab2 configure -text [mc {chrono_depose}] 
  grid .bframe.lab2 -padx 20 
  ####################################################################

  wm title . "[mc {title_m}]"

  #
  # afficher la ligne des vignettes but
  #
  image create photo im_default
  im_default copy \
	[image create photo -file [file join sysdata default.png]] \
	-subsample $glob(reduction) $glob(reduction)
  for {set d 1} { $d <= $glob(n_im_liste)} {incr d} {
    set dd [expr $d - 1]
    $c create image \
	[expr $glob(org) + $dd*$glob(v_width) + $dd*$ecart +$glob(v_width)/2] \
	[expr $glob(org) + $glob(v_height)/2] \
	-image im_default
  }
  #
  # initialiser les listes des images
  #  glob(n_im_$i)  liste des cases
  #  glob(cible_$i) liste des numros des images (entre . et .)
  #
  for { set i 1} {$i <= $glob(n_im_liste)} {incr i} {
    set glob(n_im_$i) $i
    # isoler le numro entre . et .
    set i1 [ expr $i - 1 ]
    set t [file tail [lindex $tmp_im_liste $i1]]
    set t_first [expr [string first "." $t] + 1 ]
    set t_last  [expr [string last  "." $t] - 1 ]
    set glob(cible_$i) [string range $t $t_first $t_last]
  }
  #
  # trier (bulle) glob(cible_$i)
  #
  for { set i 1 } { $i <= $glob(n_im_liste) } { incr i } {
    for { set j $glob(n_im_liste) } { $j > $i } { incr j -1 } {
      if { $glob(cible_$i) > $glob(cible_$j) } {
        # faire monter la bulle
        set g              $glob(cible_$i)
        set glob(cible_$i) $glob(cible_$j)
        set glob(cible_$j) $g
      }
    }
  }
  #
  # la mlanger
  #
  melanger_im_liste
  #
  # Crer les vignettes
  #
  for {set d 1} { $d <= $glob(n_im_liste)} {incr d} {
    image create photo glob(im_$d)
    set d_with_ext [glob [file join images $glob(chrono) *.$glob(cible_$d).*]]
    glob(im_$d) copy \
	[image create photo -file [file join $d_with_ext]] \
	-subsample $glob(reduction) $glob(reduction)
  }
  #
  # les afficher
  #
  for {set d 1} { $d <= $glob(n_im_liste)} {incr d} {
    set dd [expr $d - 1]
    $c create image \
	[expr $glob(org) + $dd*$glob(v_width) + $dd*$ecart + $glob(v_width)/2] \
	[expr $glob(org) + $glob(v_height) + 10 + $glob(v_height)/2] \
	-image glob(im_$glob(n_im_$d)) -tags drag$d
  }

  if { $glob(platform) == "unix" } {
    set heure_debut [clock clicks -milliseconds]
  } else {
    set heure_debut 0
  }
}

#####################################Gestion des vnements############################
# On associe la gestion des dplacements avec l'item portant le tag 'drag$d'
# %x %y rcuprent la position de la souris.  

for { set d 1 } { $d <= $glob(n_im_liste) } { incr d  } {
  $c bind drag$d <ButtonRelease-1> "itemStopDrag $c $d %x %y"
  $c bind drag$d <1> "itemStartDrag $c $d %x %y"
  $c bind drag$d <B1-Motion> "itemDrag $c $d %x %y"
}

bind . <Destroy> exit

# ################ Lorsque l'on clique sur la vignette (bouton appuy)
# On capture la position de la souris dans les variables lastX et lastY
# de mme que les coordonnes de la vignette 'sourcecoord'

proc itemStartDrag {c nv x y} {
  global lastX lastY sourcecoord
  set sourcecoord [$c coords current]
  set lastX [$c canvasx $x]
  set lastY [$c canvasy $y]
  . config -cursor fleur
}

# ############### Dplacement de la vignette, gestion des coordonnes avec lastX et lastY
proc itemDrag {c nv x y} {
  global lastX lastY glob
  set x [$c canvasx $x]
  set y [$c canvasy $y]
  # On deplace le tag 'drag$nv'
  $c move drag$nv [expr $x-$lastX] [expr $y-$lastY]
  set lastX $x
  set lastY $y

}

# ################ On relche la souris.
# traitement et l'analyse de la position de la vignette

proc itemStopDrag {c nv x y} {
  global glob sourcecoord  v_placees ecart

  . config -cursor left_ptr

  set coord [$c coords current]

  #On calcule le numro de la case o se trouve la vignette (xc et yc)
  set xc [expr int(([lindex $coord 0] - $glob(v_width)/2)/$glob(v_width)) + 1 ]
  set yc [expr int(([lindex $coord 1] - $glob(v_height)/2)/$glob(v_height))]

  # On teste si la vignette est dans une case valide

  if {$xc==$glob(n_im_$nv) && $yc==0} {
    # oui, on dplace la vignette
    set i [$c find withtag drag$nv]
    $c itemconf $i -tag dead ;# ne plus dplacer
    set dd [expr $xc - 1 ]
    $c coords $i \
	[expr $glob(org) + $dd*$glob(v_width) + $dd*$ecart + $glob(v_width)/2] \
	[expr $glob(org) + $glob(v_height)/2] \

    incr v_placees 1    
    if { $v_placees <  $glob(n_im_liste) } {
      return 
    } else {
      .bframe.lab2 configure -text [mc {Bravo}]
      sauver_trace_parcours

      after [expr $glob(attente) * 1000] {
        set glob(session_finie) non
      }

      vwait glob(session_finie)

      if { $glob(session_finie) == "non" } {
	lanceappli_withdraw choisir_activite.tcl
      } else {
        # exit
      }

      return 
    } 
  } else {
    # gestion des erreurs
    bell
    set i [$c find withtag drag$nv]
    $c coords $i [lindex $sourcecoord 0] [lindex $sourcecoord 1]
  }
}

##################################################################"

  # Relire le nom rgl de l'utilisateur sous windows
  if {$glob(platform) == "windows"} {
    catch {set f [open [file join $glob(home_mulot) reglages trace_user] "r"]}
    gets $f glob(trace_user)
    close $f
  }

main_loop $c
