#!/bin/sh
# chrono_numeroter.tcl du projet mulot.tcl
# \
exec wish "$0" ${1+"$@"}

#*************************************************************************
#  Copyright (C) 2002 Eric Seigne <erics@rycks.com>
# 
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
# 
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
# 
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# 
#**************************************************************************
#  File  : $Id: chrono_numeroter.tcl,v 1.2 2005/03/21 08:38:25 abuledu_andre Exp $
#  Author  : andre.connes@toulouse.iufm.fr
#  Date    : 10/07/2003 Modification : 21/12/2004
#  Licence : GNU/GPL Version 2 ou plus
# 
#  Description:
#  ------------
# 
#  @version    
#  @author     Andre Connes
#  @modifier   
#  @project    Le terrier
#  @copyright  Eric Seigne 24/04/2002
# 
#  *************************************************************************

source mulot.conf
source msg.tcl
#source eval.tcl

set glob(chrono) [lindex $argv 0]

################################################

proc lanceappli {appli {niveau 0}} {
	set appli [file join $appli]
	exec wish $appli $niveau &
}

################################################

  #
  # langue par dfaut
  #
  set f [open [file join $glob(home_reglages) lang.conf] "r"]
  gets $f lang
  close $f
  ::msgcat::mclocale $lang
  ::msgcat::mcload [file join [file dirname [info script]] msgs]


set dir_origine [pwd]

if { $glob(platform) == "windows" } {
  set f [open [file join $glob(home_mulot) reglages trace_user] "r"]
  set glob(trace_user) [gets $f]
  close $f
}

#charger la liste des images
# set f [open [file join $glob(home_mulot) reglages dir_images.conf] "r"]
# set glob(chrono) [gets $f]

  set glob(tmp_im_liste) [glob [file join images $glob(chrono) *.*]]
  set glob(n_im_liste) [llength $glob(tmp_im_liste)]
  if { $glob(n_im_liste) < 3 || $glob(n_im_liste) > 5 } {
    # pas assez ou trop d'images
    tk_messageBox -default ok \
	-message "Nombre d'images entre 3 et 5\nSVP" -parent . 
    lanceappli mulot.tcl
    exit
  }

# facteur de rduction des vignettes
set glob(reduction) 4

set ecart 10
# modifier les dimensions de la fentre  cause du nombre de vignettes
set glob(height) [expr 2*400/$glob(reduction)+30+3]
set glob(width) [expr $glob(n_im_liste)*600/$glob(reduction)+$glob(n_im_liste)*$ecart]

# dimension des vignettes
set glob(v_height) [expr 400/$glob(reduction)]
set glob(v_width)  [expr 600/$glob(reduction)]

########################### On cre la fentre principale###########################

# placement de la fentre en haut et  gauche de l'cran

. configure -bg $glob(bgcolor)
wm geometry . +0+0

frame .frame -width $glob(width) -height $glob(height) -bg $glob(bgcolor)
pack .frame -side top -fill both -expand yes


# #######################On cre un canvas###########################################
# charg d'accueillir les sorties graphiques,
# qui peuvent tre des images, des textes, des formes gomtriques ...

set c .frame.c
canvas $c -width $glob(width) -height $glob(height) -bg $glob(bgcolor) -highlightbackground $glob(bgcolor)
pack $c -expand true 

# #################################################################################
# frame en bas avec boutons 'continuer', flches gauche et droite, le score et une tiquette de controle de la rponse

frame .bframe -bg $glob(bgcolor)
pack .bframe -side bottom -expand true
label .bframe.lab2 -bg $glob(bgcolor) -font 12x24
grid .bframe.lab2 -column 1 -padx 20 -row 1

label .bframe.lab3 -bg $glob(bgcolor) -font 12x24
grid .bframe.lab3 -column 5 -padx 20 -row 1

button .bframe.but_quitter -image \
	[image create photo fquitter -file [file join sysdata quitter_minus.gif]] \
	-command "cd \"$dir_origine\"; lanceappli mulot.tcl; exit"
grid .bframe.but_quitter -column 6  -row 1

# ####################### proc main_loop ########################
proc main_loop {c} {
  global glob nv im_choix heure_debut ecart
  # nv = numro de vignette

  $c delete all

  .bframe.lab2 configure -text [mc {chrono_depose}] 
  grid .bframe.lab2 -padx 20 
  ####################################################################

  wm title . "[mc {editer_chrono}]"

  #
  # afficher la ligne des vignettes but
  #
  image create photo im_default
  im_default copy \
	[image create photo -file [file join sysdata default.png]] \
	-subsample $glob(reduction) $glob(reduction)
  for {set d 0} { $d < $glob(n_im_liste)} {incr d} {
    $c create image \
	[expr $glob(org) + $d*$glob(v_width) + $d*$ecart +$glob(v_width)/2] \
	[expr $glob(org) + $glob(v_height)/2] \
	-image im_default
  }
  #
  # Crer les vignettes et afficher
  #
  for {set d 0} { $d < $glob(n_im_liste)} {incr d} {
    set glob(n_im_$d) [lindex $glob(tmp_im_liste) $d]
    set glob(new_im_$d) "undef"
    image create photo glob(im_$d)
    glob(im_$d) copy \
	[image create photo -file $glob(n_im_$d)] \
	-subsample $glob(reduction) $glob(reduction)
    $c create image \
	[expr $glob(org) + $d*$glob(v_width) + $d*$ecart + $glob(v_width)/2] \
	[expr $glob(org) + $glob(v_height)   + $glob(v_height)/2] \
	-image glob(im_$d) -tags drag$d
  }
}

#####################################Gestion des vnements############################
# On associe la gestion des dplacements avec l'item portant le tag 'drag$d'
# %x %y rcuprent la position de la souris.  

for { set d 0 } { $d < $glob(n_im_liste) } { incr d  } {
  $c bind drag$d <ButtonRelease-1> "itemStopDrag $c $d %x %y"
  $c bind drag$d <1> "itemStartDrag $c $d %x %y"
  $c bind drag$d <B1-Motion> "itemDrag $c $d %x %y"
}

bind . <Destroy> exit

# ################ Lorsque l'on clique sur la vignette (bouton appuy)
# On capture la position de la souris dans les variables lastX et lastY
# de mme que les coordonnes de la vignette 'sourcecoord'

proc itemStartDrag {c nv x y} {
  global lastX lastY sourcecoord
  set sourcecoord [$c coords current]
  set lastX [$c canvasx $x]
  set lastY [$c canvasy $y]
  . config -cursor fleur
}

# ############### Dplacement de la vignette, gestion des coordonnes avec lastX et lastY
proc itemDrag {c nv x y} {
  global lastX lastY glob
  set x [$c canvasx $x]
  set y [$c canvasy $y]
  # On deplace le tag 'drag$nv'
  $c move drag$nv [expr $x-$lastX] [expr $y-$lastY]
  set lastX $x
  set lastY $y

}

# ################ On relche la souris.
# traitement et l'analyse de la position de la vignette

proc itemStopDrag {c nv x y} {
  global glob sourcecoord  ecart

  . config -cursor left_ptr

  set coord [$c coords current]

  set v_placees 0

  #On calcule le numro de la case o se trouve la vignette (xc et yc)
  set xc [expr int(([lindex $coord 0] - $glob(v_width)/2)/$glob(v_width))  ]
  set yc [expr int(([lindex $coord 1] - $glob(v_height)/2)/$glob(v_height))]

  # On teste si la vignette est dans une case valide

  if {$xc>= 0 && $xc <$glob(n_im_liste) \
	&& $yc==0 \
	&& $glob(new_im_$xc) == "undef" } {
    # oui, on dplace la vignette
    set i [$c find withtag drag$nv]
    set glob(new_im_$xc) $glob(n_im_$nv)
    $c itemconf $i -tag dead ;# ne plus dplacer
    $c coords $i \
	[expr $glob(org) + $xc*$glob(v_width) + $xc*$ecart + $glob(v_width)/2] \
	[expr $glob(org) + $glob(v_height)/2]
    for { set k 0 } { $k < $glob(n_im_liste) } { incr k } {
      if { $glob(new_im_$k) != "undef" } {
        incr v_placees
      }    
    }
    if { $v_placees <  $glob(n_im_liste) } {
      return 
    } else {
      sauver_chrono
      lanceappli mulot.tcl; destroy .; exit
      return 
    } 
  } else {
    # gestion des erreurs
    bell
    set i [$c find withtag drag$nv]
    $c coords $i [lindex $sourcecoord 0] [lindex $sourcecoord 1]
  }
} ;# stopItemDrag

proc sauver_chrono {} {
  global glob
  for { set n 0 } { $n < $glob(n_im_liste) } { incr n } {
    set tmp $glob(new_im_$n)
    set tmp_dirname [file dirname $tmp]
    set tmp_tail [file tail $tmp]
    set tmp_racine [lindex [split $tmp_tail "."] 0]
    set tmp_ext [lindex [split $tmp_tail "."] end] 
    set nn [expr $n +1 ]
    append glob(new_image_$n) $tmp_dirname "/" $tmp_racine "." $nn "." $tmp_ext
    # attention, pour renommer, ne pas craser, copier puis effacer
    file copy $glob(new_im_$n) $glob(new_im_$n)tmp
  }
  # pour terminer, effacer original et renommer copie
  for { set n 0 } { $n < $glob(n_im_liste) } { incr n } {
    file delete $glob(new_im_$n)
    file rename $glob(new_im_$n)tmp $glob(new_image_$n)
  }
  tk_messageBox -default ok -message termin -parent . 
}

##################################################################"

  # Relire le nom rgl de l'utilisateur sous windows
  if {$glob(platform) == "windows"} {
    catch {set f [open [file join $glob(home_mulot) reglages trace_user] "r"]}
    gets $f glob(trace_user)
    close $f
  }

main_loop $c
