#!/bin/sh
# effacer_dossier.tcl du projet mulot.tcl
# \
exec wish "$0" ${1+"$@"}

#*************************************************************************
#  Copyright (C) 2002 Eric Seigne <erics@rycks.com>
# 
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
# 
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
# 
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# 
#**************************************************************************
#  File  : $Id: effacer_dossier.tcl,v 1.4 2005/03/22 14:12:56 abuledu_andre Exp $
#  Author  : andre.connes@toulouse.iufm.fr
#  Date    : 23/06/2003 Modification : 22/03/2005
#  Licence : GNU/GPL Version 2 ou plus
# 
#  Description:
#  ------------
# 
#  @version    
#  @author     Andre Connes
#  @modifier   
#  @project    Le terrier
#  @copyright  Eric Seigne 24/04/2002
# 
#  *************************************************************************

source mulot.conf
source msg.tcl

  #
  # langue par dfaut
  #
  set f [open [file join $glob(home_reglages) lang.conf] "r"]
  gets $f lang
  close $f
  ::msgcat::mclocale $lang
  ::msgcat::mcload [file join [file dirname [info script]] msgs]

set dir_origine [pwd]

########## Construction de l'interface###########
#frame we pour lister les dossiers images
wm geometry . +50+50
wm title . [mc {effacer_dossier}]

frame .we -background #aaaaaa -height 420 -width 320
grid .we -column 0 -row 0

#si abuledu ncessairement l'utilisateur est prof d'aprs mulot.tcl
if { ! [file exists /etc/abuledu] } {
  label .we.passwd -text [mc {Password}] -bg red
  place .we.passwd -x 100 -y 10
  entry .we.password -show "*"
  place .we.password -x 100 -y 30
  .we.password delete 0 end
}

listbox .we.liste -background #c0c0c0 -height 10 -width 20 -yscrollcommand ".we.scroll set"
scrollbar .we.scroll -command ".we.liste yview"
place .we.liste -x 100 -y 70
place .we.scroll -x 227 -y 70 -height 172
label .we.menu3 -text [mc {choix2clics}] -background #aaaaaa
place .we.menu3 -x 80 -y 50
entry .we.text
place .we.text -x 100 -y 280
.we.text delete 0 end

button .we.ok -text [mc {Faire} ] -command "supprimer_dossier"
place .we.ok -x 95 -y 305
button .we.cancel -text [mc {Quitter} ] \
	-command "cd \"$dir_origine\" ; lanceappli mulot.tcl ; exit"
place .we.cancel -x 185 -y 305

bind .we.liste <Double-ButtonRelease-1> "capturenom"

# lister les dossiers images
proc peupleliste {} {
  .we.liste delete 0 end
  catch {foreach i [lsort [glob -directory images -type d *]] {
	  if { $i == "images/CVS" } continue
	  .we.liste insert end [file tail $i]
        }
  }
}
peupleliste 


proc capturenom {} {
    .we.text delete 0 end
    .we.text insert 0 [.we.liste get active]
}

proc supprimer_dossier {} {
  global glob
  # astuce : si abuledu le mot de passe est auto mais
  #          droits d'effacement pour les profs only
  if {[file exists /etc/abuledu]} {
    set pass $glob(passwd)
  } else {
    set pass [.we.password get]
  }
  if {$pass == $glob(passwd)} {
    catch {file delete -force images/[.we.text get]}
    peupleliste
  }
  .we.text delete 0 end
}

proc lanceappli {appli {niveau 0}} {
	set appli [file join $appli]
	exec wish $appli $niveau &
}
