#!/bin/sh
#mulot.tcl
# \
exec wish "$0" ${1+"$@"}

#*************************************************************************
#  Copyright (C) 2002 Eric Seigne <erics@rycks.com>
# 
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
# 
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
# 
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# 
#**************************************************************************
#  File  : $Id: glisser_mulot.tcl,v 1.5 2005/03/21 08:38:25 abuledu_andre Exp $
#  Author  : andre.connes@toulouse.iufm.fr
#  Date    : 10/07/2003 Modification : 01/08/2003
#  Licence : GNU/GPL Version 2 ou plus
# 
#  Description:
#  ------------
# 
#  @version    
#  @author     Andre Connes
#  @modifier   
#  @project    Le terrier
#  @copyright  Eric Seigne 24/04/2002
# 
#  *************************************************************************

source mulot.conf
source msg.tcl
source eval.tcl

  #
  # langue par dfaut
  #
  set f [open [file join $glob(home_reglages) lang.conf] "r"]
  gets $f lang
  close $f
  ::msgcat::mclocale $lang
  ::msgcat::mcload [file join [file dirname [info script]] msgs]


if { $glob(platform) == "windows" } {
  set f [open [file join $glob(home_mulot) reglages trace_user] "r"]
  set glob(trace_user) [gets $f]
  close $f
}

# modifier la largeur de la fentre  cause de la largeur des vignettes
set glob(width) [expr $glob(width) + 150 ]

#charger la liste des images
  set f [open [file join $glob(home_mulot) reglages dir_images.conf] "r"]
  set glob(dossier) [gets $f]
  set tmp_choix [glob [file join images $glob(dossier) *.*]]
  foreach i $tmp_choix {
    lappend im_choix(im_liste) [file tail $i]
  }

# Dcommenter la ligne suivante si Img est installe
# package require Img

########################### On cre la fentre principale###########################

# placement de la fentre en haut et  gauche de l'cran

. configure -bg $glob(bgcolor)
wm geometry . +0+0

frame .frame -width $glob(width) -height $glob(height) -bg $glob(bgcolor)
pack .frame -side top -fill both -expand yes


# #######################On cre un canvas###########################################
# charg d'accueillir les sorties graphiques,
# qui peuvent tre des images, des textes, des formes gomtriques ...

set c .frame.c
canvas $c -width $glob(width) -height $glob(height) -bg $glob(bgcolor) -highlightbackground $glob(bgcolor)
pack $c -expand true 

################################################

# ##
# sauver trace-lve et parcours
# ##

proc sauver_trace_parcours {} {
  global glob heure_debut

  ## trace
  # utilisateur/classe/date/dure/didacticiel/nvignettes/version
  set eleve $glob(trace_user)
  set titre "mulot-$glob(version)"
  set categorie "DragDrop=$glob(nvignettes)"
  if { $glob(platform) == "unix" } {
    set heure_fin [clock clicks -milliseconds]
    set duree [expr abs(int($heure_debut-$heure_fin)/1000)]
    set date_heure [clock format [clock seconds] -format "%c"]
    set quoi "classe \{$date_heure\} $duree"
  } else {
    set quoi "classe \{Ddd Mmm 99 00:00:00 9999\} 0"
  }

  enregistreval $titre $categorie $quoi $eleve

}

# #################################################################################
# frame en bas avec boutons 'continuer', flches gauche et droite, le score et une tiquette de controle de la rponse

frame .bframe -bg $glob(bgcolor)
pack .bframe -side bottom -expand true
label .bframe.lab2 -bg $glob(bgcolor) -font 12x24
grid .bframe.lab2 -column 1 -padx 20 -row 1

label .bframe.lab3 -bg $glob(bgcolor) -font 12x24
grid .bframe.lab3 -column 5 -padx 20 -row 1

button .bframe.but_quitter -image \
  [image create photo fquitter -file [file join sysdata quitter_minus.gif]] -command exit
grid .bframe.but_quitter -column 6  -row 1

# ####################### proc main ########################
proc main {c} {
  global glob nv im_choix heure_debut v_placees
  # nv = numro de vignette
  # v_placees = nombre de vignettes places

  $c delete all
  set v_placees 0

  .bframe.lab2 configure -text [mc {glisse_depose}] 
  grid .bframe.lab2 -padx 20 
  ####################################################################

  wm title . "[mc {title_m}]"

  ################### choix de l'image
  # choisir une image dans la liste im_choix(im_liste)
  set r [expr int(rand()*[llength $im_choix(im_liste)])]
  set im_choix(fname) [lindex $im_choix(im_liste) $r]
  set im_choix(image) [image create photo \
	-file [file join images $glob(dossier) $im_choix(fname)]]
  # dim image choisie
  set im_choix(height) [image height $im_choix(image)]
  set im_choix(width) [image width $im_choix(image)]
  # dim des vignettes (par crop)
  set im_choix(v_width) [expr $im_choix(width) / $glob(nvignettes)]
  set im_choix(v_height) [expr $im_choix(height) / $glob(nvignettes)]

  #################### afficher l'image de fond ###############################
  $c create image \
	[expr $glob(org) + $im_choix(v_width) + int($im_choix(width)/2)+1] \
	[expr $glob(org) + int($im_choix(height)/2)+1] \
	-image $im_choix(image)

  ################### liste des vignettes ##############################
  # im_choix(vignettes_liste) contiendra les numros de vignettes
  set im_choix(vignettes_liste) {}
  while { [llength $im_choix(vignettes_liste)] < $glob(nvignettes) } {
    set r [expr int(rand()*[expr $glob(nvignettes)*$glob(nvignettes)])]
    if { [lsearch $im_choix(vignettes_liste) $r] == -1 } {
      set im_choix(vignettes_liste) [linsert $im_choix(vignettes_liste) end $r]
    }
  }

  ####################Cration des vignettes ############### ###################
  # Les vignettes peuvent constituer des objets
  # indpendants, utile si on veut leur associer des comportements

  # on cre puis on affiche les vignettes
  for {set nv 0} { $nv < $glob(nvignettes)} {incr nv 1} {
    set r [lindex $im_choix(vignettes_liste) $nv]
    image create photo vignette($nv)
    vignette($nv) copy $im_choix(image) -from \
        [expr int($r/$glob(nvignettes))*$im_choix(v_width)] [expr ($r%$glob(nvignettes))*$im_choix(v_height)] \
        [expr (int($r/$glob(nvignettes))+1)*$im_choix(v_width)] [expr (($r%$glob(nvignettes))+1)*$im_choix(v_height)]
    $c create image \
	[expr $glob(org) + int($im_choix(v_width)/2)] \
	[expr $glob(org) + $nv + $nv*$im_choix(v_height) + int($im_choix(v_height)/2)] \
	-image vignette($nv) -tags drag$nv
  }

  if { $glob(platform) == "unix" } {
    set heure_debut [clock clicks -milliseconds]
  } else {
    set heure_debut 0
  }
}

#####################################Gestion des vnements############################
# On associe la gestion des dplacements avec l'item portant le tag 'drag$nv'
# %x %y rcuprent la position de la souris.  

for { set i 0 } { $i < $glob(nvignettes) } { incr i 1 } {
  $c bind drag$i <ButtonRelease-1> "itemStopDrag $c $i %x %y"
  $c bind drag$i <1> "itemStartDrag $c $i %x %y"
  $c bind drag$i <B1-Motion> "itemDrag $c $i %x %y"
}

bind . <Destroy> exit

# ################ Lorsque l'on clique sur la vignette (bouton appuy)
# On capture la position de la souris dans les variables lastX et lastY
# de mme que les coordonnes de la vignette 'sourcecoord'

proc itemStartDrag {c nv x y} {
  global lastX lastY sourcecoord
  set sourcecoord [$c coords current]
  set lastX [$c canvasx $x]
  set lastY [$c canvasy $y]
  . config -cursor fleur
}

# ############### Dplacement de la vignette, gestion des coordonnes avec lastX et lastY
proc itemDrag {c nv x y} {
  global lastX lastY glob im_choix
  set x [$c canvasx $x]
  set y [$c canvasy $y]
  # On deplace le tag 'drag$nv'
  $c move drag$nv [expr $x-$lastX] [expr $y-$lastY]
  set lastX $x
  set lastY $y

  set coord [$c coords current]
  #On calcule le numro de la case o se trouve la vignette (xc et yc)
  set xc [expr int(([lindex $coord 0] - $im_choix(v_width))/$im_choix(v_width))]
  set yc [expr int([lindex $coord 1]/$im_choix(v_height))]

  set r [lindex $im_choix(vignettes_liste) $nv]
  set xindice [expr int($r/$glob(nvignettes))]
  set yindice [expr $r%$glob(nvignettes)]

  # On teste si la vignette est dans une case valide

  if {$xc==$xindice && $yc==$yindice} {
    vignette($nv) configure -gamma 2.5
  } else {
    vignette($nv) configure -gamma 1.0
  }

}

# ################ On relche la souris.
# traitement et l'analyse de la position de la vignette

proc itemStopDrag {c nv x y} {
  global glob im_choix sourcecoord  v_placees

  . config -cursor left_ptr

  set coord [$c coords current]
  #On calcule le numro de la case o se trouve la vignette (xc et yc)
  set xc [expr int(([lindex $coord 0] - $im_choix(v_width))/$im_choix(v_width))]
  set yc [expr int([lindex $coord 1]/$im_choix(v_height))]

  set r [lindex $im_choix(vignettes_liste) $nv]
  set xindice [expr int($r/$glob(nvignettes))]
  set yindice [expr $r%$glob(nvignettes)]

  # On teste si la vignette est dans une case valide

  if {$xc==$xindice && $yc==$yindice} {
    # Si oui, on dplace le personnage             
      set i [$c find withtag drag$nv] 
      $c coords $i \
	[expr $glob(org) + $im_choix(v_width) + $xc*$im_choix(v_width) + int($im_choix(v_width)/2)] \
	[expr $glob(org) + $yc*$im_choix(v_height) + int($im_choix(v_height)/2)]
      $c itemconf $i -tag dead
#     vignette($nv) configure -gamma 1.0
      vignette($nv) blank
      image delete vignette($nv)
    incr v_placees 1    
    if { $v_placees <  $glob(nvignettes) } {
      return 
    } else {
      .bframe.lab2 configure -text [mc {Bravo}]
      sauver_trace_parcours

      after [expr $glob(attente) * 1000] {
        set glob(session_finie) non
      }

      vwait glob(session_finie)

      if { $glob(session_finie) == "non" } {
        main $c
      } else {
        # exit
      }

      return 
    } 
  } else {
    # gestion des erreurs
    bell
    set i [$c find withtag drag$nv]
    $c coords $i [lindex $sourcecoord 0] [lindex $sourcecoord 1]
  }
}

##################################################################"

  # Relire le nom rgl de l'utilisateur sous windows
  if {$glob(platform) == "windows"} {
    catch {set f [open [file join $glob(home_mulot) reglages trace_user] "r"]}
    gets $f glob(trace_user)
    close $f
  }

main $c
