#!/bin/sh
#mulot.tcl
# \
exec wish "$0" ${1+"$@"}

#*************************************************************************
#  Copyright (C) 2002 Andr Connes <davidlucardi@aol.com>
#  Copyright (C) 2002 Andr Connes <andre.connes@toulouse.iufm.fr>
# 
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
# 
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# 
#**************************************************************************
#  File  : mulot.tcl
#  Author  : Andr Connes <andre.connes@toulouse.iufm.fr>
#  Modifier:
#  Date    : 15/04/2003 modifi le 06/12/2004
#  Licence : GNU/GPL Version 2 ou plus
# 
#  Description:
#  ------------
# 
#  @version    $Id: mulot.tcl,v 1.11 2005/03/21 08:38:25 abuledu_andre Exp $
#  @author     Andr Connes
#  @modifier   
#  @project    Le terrier
#  @copyright  Andr Connes
# 
#***********************************************************************
global sysFont glob

source mulot.conf
source msg.tcl
source aider.tcl
source fonts.tcl

set maxcolonnes 2

#wm resizable . 0 0
. configure -background blue
wm geometry . +0+0
wm title . "[mc {title_m}]"

# gestion de l'espace de l'utilisateur
  if {![file exists [file join  $glob(home_mulot)]]} {
	catch { file mkdir [file join $glob(home_mulot)]}
  }
  if {![file exists [file join  $glob(home_reglages)]]} {
	catch { file mkdir [file join $glob(home_reglages)] }
  }
  #
  # langue par dfaut
  #
  if {![file exists [file join  $glob(home_reglages) lang.conf]]} {
	set f [open [file join $glob(home_reglages) lang.conf] "w"]
	puts $f "fr"
	close $f
  }
  set f [open [file join $glob(home_reglages) lang.conf] "r"]
  gets $f lang
  close $f
  ::msgcat::mclocale $lang
  ::msgcat::mcload [file join [file dirname [info script]] msgs]

  if {![file exists [file join  $glob(home_reglages) dir_exos.conf]]} {
	set f [open [file join $glob(home_reglages) dir_exos.conf] "w"]
	puts $f "Commun"
	close $f
  }

  catch { file mkdir [file join $glob(home_msgs)] }
  # astuce suivante : ajoute automatiquement toute nouvelle langue chez l'utilisateur
  foreach f [glob [file join msgs *.msg]] {
	catch { file copy [file join $f] [file join $glob(home_msgs)]}
  }
  if {![file exists [file join  $glob(trace_dir)]]} {
	file mkdir [file join $glob(trace_dir)]
  }
  catch { file mkdir [file join $glob(home_chemin) grilles] }
  #
  # tat des boutons des menus
  #
  set glob(etat_boutons) normal
  set rdir $glob(home_reglages)
  set classe defaut
  if {  [file exists /etc/abuledu] } {
    # recherche de la classe
    set nom_utilisateur [file tail $env(HOME)]
    set cclasse "profs:"
    catch { set cclasse [exec grep $nom_utilisateur [file join /etc/group]] }
    # attention ! si prof autoriser
    if { [string range $env(HOME) 5 11] == "/profs/" } {
      set cclasse "profs:"
    }
    set classe [lindex [split $cclasse ":"] 0]
    # recherche du rpertoire de rglage de la classe
    if {[file exists /usr/share/abuledu/applications/abuledu-mulot]} {
      set rdir "/usr/share/abuledu/applications/abuledu-mulot/reglages"
    }
    if {[file exists /usr/share/abuledu-mulot]} {
      set rdir "/usr/share/abuledu-mulot/reglages"
    }
  }
  # maintenant classe = profs ou cp, ce1, etc. ou defaut 
  # et rdir = 4abuledu_mdk or 4abuledu_debian or glob(home_reglages)  
  # dfinir l'tat des boutons des menus si non prof
  if { $classe != "profs" && [file exists [file join $rdir boutons.$classe]] } {
    set f [open [file join $rdir boutons.$classe] "r"]
    gets $f glob(etat_boutons)
    close $f
  }

proc lanceappli {appli {niveau 0 }} {
	set appli [file join $appli]
	exec wish $appli $niveau &
}

proc lanceappli_withdraw {appli {niveau 0}} {
	destroy .
	set appli [file join $appli]
	exec wish $appli $niveau &
}

proc setlang {lang} {
  global env glob
  set env(LANG) $lang
  catch {set f [open [file join $glob(home_reglages) lang.conf] "w"]}
  puts $f [file rootname [file tail $lang]]
  close $f
  lanceappli_withdraw mulot.tcl
}

proc set_img_dir {img_dir} {
  global glob
  catch {set f [open [file join $glob(home_reglages) dir_images.conf] "w"]}
  puts $f $img_dir
  close $f
  lanceappli_withdraw choisir_activite.tcl
}

proc setwindowsusername {} {
    global user
    catch {destroy .utilisateur}
    toplevel .utilisateur -background grey -width 250 -height 100
    wm geometry .utilisateur +50+50
    frame .utilisateur.frame -background grey -width 250 -height 100
    pack .utilisateur.frame -side top
    label .utilisateur.frame.labobj -font {Helvetica 10} -text "[mc {Ton nom}] ?" -background grey
    pack .utilisateur.frame.labobj -side top 
    entry .utilisateur.frame.entobj -font {Helvetica 10} -width 10
    pack .utilisateur.frame.entobj -side top 
    button .utilisateur.frame.ok -background gray75 -text "Ok" -command "verifnom"
    pack .utilisateur.frame.ok -side top -pady 10
}

  proc verifnom {} {
   global glob
   set nom [string tolower [string trim [string map {\040 ""} [.utilisateur.frame.entobj get]]]]
    if {$nom ==""} {
	set nom eleve
    }
    # sauver le rglage du nom
    catch {set f [open [file join $glob(home_mulot) reglages trace_user] "w"]}
    set glob(trace_user) "$glob(trace_dir)/$nom"
    puts $f $glob(trace_user)
    close $f
    catch {destroy .utilisateur}
  } ;# fin verifnom

#########################################################"
proc main_loop {} {
  global . sysFont glob maxcolonnes env

  #
  # Creation du menu utilise comme barre de menu:
  #
  catch {destroy .menu}
  catch { destroy .frame.c}
  catch {destroy .frame}

  menu .menu -tearoff 0
  #
  # Creation du menu Fichier
  #
  menu .menu.fichier -tearoff 0
  .menu add cascade -state $glob(etat_boutons) \
	-label [mc {Fichier}] -menu .menu.fichier

  set etat_fichier "normal"
  if {  [file exists /etc/abuledu] && \
	[string range $env(HOME) 5 11] != "/profs/" } {
    set etat_fichier "disabled"
  }

  menu .menu.fichier.images -tearoff 0
  .menu.fichier add cascade -label [mc {Images}] \
	-state $etat_fichier \
	-menu .menu.fichier.images
  .menu.fichier.images add command -label [mc {ajouter_dossier}] \
	-command "lanceappli ajouter_dossier.tcl"
  .menu.fichier.images add command -label [mc {ajouter_images}] \
	-command "lanceappli_withdraw ajouter_images.tcl"
  .menu.fichier.images add separator
  .menu.fichier.images add command -label [mc {editer_chrono}] \
	-command "lanceappli_withdraw chrono_editer.tcl"
  .menu.fichier.images add separator
  .menu.fichier.images add command -label [mc {effacer_dossier}] \
	-command "lanceappli_withdraw effacer_dossier.tcl"
  .menu.fichier.images add command -label [mc {effacer_images}] \
	-command "lanceappli effacer_images.tcl"

if { [file exists /etc/abuledu ] } {
  menu .menu.fichier.menus -tearoff 0
  .menu.fichier add cascade -label [mc {Menus}] \
	-state $etat_fichier \
	-menu .menu.fichier.menus
  .menu.fichier.menus add command -label [mc {autoriser_menus}] \
	-command "lanceappli autoriser_menus.tcl normal"
  .menu.fichier.menus add command -label [mc {non_autoriser_menus}] \
	-command "lanceappli autoriser_menus.tcl disabled"
}
  .menu.fichier add separator

  .menu.fichier add command -label [mc {Quitter}] -command exit

  #
  # Creation du menu Options
  #
  menu .menu.options -tearoff 0
  .menu add cascade -state $glob(etat_boutons) \
	-label [mc {Options}] -menu .menu.options

  # langues
  menu .menu.options.lang -tearoff 0 
  .menu.options add cascade -label "[mc {Langue}]" -menu .menu.options.lang

  foreach i [glob [file join  $glob(home_msgs) *.msg]] {
    set langue [string map {.msg "" } [file tail $i]]
    .menu.options.lang add radio -label $langue -variable langue -command "setlang $langue"
  }

  # dossiers images
  menu .menu.options.img_dirs -tearoff 0 
  .menu.options add cascade -label "[mc {Dossiers}]" -menu .menu.options.img_dirs

  #charger la liste des dossiers images (peu importe le type ?)
  set all_img_dirs [glob -directory images -type d *]
  # verification : non CVS et non vide
  foreach tmp_img_dir $all_img_dirs {
    if { $tmp_img_dir == "images/CVS" } continue
    if { ! [catch {set t [glob [file join $tmp_img_dir *]]}] } {
      lappend glob(img_dirs) [file tail $tmp_img_dir]
    }
  }
  set glob(img_dirs) [lsort $glob(img_dirs)]

  foreach d $glob(img_dirs) {
    .menu.options.img_dirs add radio \
	-label $d -variable img_dir \
	-command "set_img_dir $d"
  }

  # Nom de l'utilisateur sous windows
  if {$glob(platform) == "windows"} {
    .menu add command -label [mc {Utilisateur}] -command "setwindowsusername"
  }
  #
  # Creation du menu aide
  #
  menu .menu.aide -tearoff 0
  .menu add cascade -state $glob(etat_boutons) \
	-label [mc {Aide}] -menu .menu.aide
  .menu.aide add command -label [mc {Aide}] -command aider
  .menu.aide add command -label [mc { propos ...}] -command "source apropos.tcl"

  . configure -menu .menu

  #######################################################################"
  . configure -background blue
  frame .frame -background blue -height 300 -width 200
  pack .frame -side top -fill both -expand yes
  ###################On cre un canvas####################################

  set c .frame.c
  canvas $c -width $glob(width) -height $glob(height) -bg blue -highlightbackground blue
  pack $c -expand true

  set nligne 0
  set ncolonne 0
  #
  # cration des boutons  la vole en utilisant la premire image
  #
  foreach d $glob(img_dirs) {
    set i [lindex [glob [file join images $d *]] 0]
    image create photo but_$d
    but_$d copy [image create photo -file [file join $i]] \
	-subsample 5 5
    # chronologie ?
    set tail_i [file tail $i]
    set first_point [string first "." $tail_i]
    set last_point  [string last  "." $tail_i]
    set between [string range $tail_i $first_point $last_point]
    if { [string length $between] > 1 } {
      set relief ridge
    } else {
      set relief raised
    }
    button $c.$d \
        -image but_$d \
        -borderwidth 10 -cursor heart -relief $relief \
        -command "set_img_dir $d"
    grid $c.$d -column $ncolonne -row $nligne -sticky e -padx 10 -pady 10
    incr ncolonne
    if { $ncolonne > $maxcolonnes } {
      set ncolonne 0
      incr nligne
    } 
  }

  if { $nligne == 0 } {
    incr nligne ;# pour un affichage russi !
  }
  button $c.quitter \
        -image [image create photo -file sysdata/quitter_minus.gif] \
        -borderwidth 10 -cursor heart \
        -command exit
  grid $c.quitter -column 3 -row $nligne -sticky e -padx 10 -pady 10

  set myimage [image create photo -file sysdata/background.gif]
  label $c.imagedisplayer -image $myimage -background blue
  grid $c.imagedisplayer -column 3 -row 0 -sticky e

} ;# fin main_loop

#
# Bindings
#
bind . <Control-q> {exit}

########################################################################"

  # Nom de l'utilisateur par dfaut sous windows
  if {$glob(platform) == "windows"} {
    set nom eleve
    # sauver le rglage du nom
    catch {set f [open [file join $glob(home_mulot) reglages trace_user] "w"]}
    puts $f "$glob(trace_dir)/$nom"
    close $f
  }

main_loop
