#!/bin/sh
#mulot.tcl
# \
exec wish "$0" ${1+"$@"}

#*************************************************************************
#  Copyright (C) 2002 Eric Seigne <erics@rycks.com>
# 
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
# 
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
# 
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# 
#**************************************************************************
#  File  : $Id: parcourir_mulot.tcl,v 1.5 2005/03/21 08:38:25 abuledu_andre Exp $
#  Author  : andre.connes@toulouse.iufm.fr
#  Date    : 10/07/2003 Modification : 16/02/2004
#  Licence : GNU/GPL Version 2 ou plus
# 
#  Description:
#  ------------
# 
#  @version    
#  @author     Andre Connes
#  @modifier   
#  @project    Le terrier
#  @copyright  Eric Seigne 24/04/2002
# 
#  *************************************************************************

source mulot.conf
source msg.tcl
source eval.tcl

  #
  # langue par dfaut
  #
  set f [open [file join $glob(home_reglages) lang.conf] "r"]
  gets $f lang
  close $f
  ::msgcat::mclocale $lang
  ::msgcat::mcload [file join [file dirname [info script]] msgs]


set ident $tcl_platform(user)

#charger la liste des images
  set f [open [file join $glob(home_mulot) reglages dir_images.conf] "r"]
  set glob(dossier) [gets $f]
  set limages [glob [file join images $glob(dossier) *.*]]

if { $glob(platform) == "windows" } {
  set f [open [file join $glob(home_mulot) reglages trace_user] "r"]
  set glob(trace_user) [gets $f]
  close $f
}

########################### On cre la fentre principale###########################

# placement de la fentre en haut et  gauche de l'cran

. configure -bg $glob(bgcolor)
wm geometry . +0+0

frame .frame -width $glob(width) -height $glob(height) -bg $glob(bgcolor)
pack .frame -side top -fill both -expand yes


# #######################On cre un canvas###########################################
# charg d'accueillir les sorties graphiques,
# qui peuvent tre des images, des textes, des formes gomtriques ...

set c .frame.c
canvas $c -width $glob(width) -height $glob(height) -bg $glob(bgcolor) -highlightbackground $glob(bgcolor)
pack $c -expand true 

################################################

# ##
# sauver trace-lve et parcours
# ##

proc sauver_trace_parcours {} {
  global glob heure_debut

  ## trace
  # utilisateur/classe/date/dure/didacticiel/difficulte/version
  set eleve $glob(trace_user)
  set titre "mulot-$glob(version)"
  set categorie "Piste=$glob(difficulte_piste)"
  if { $glob(platform) == "unix" } {
    set heure_fin [clock clicks -milliseconds]
    set duree [expr abs(int($heure_debut-$heure_fin)/1000)]
    set date_heure [clock format [clock seconds] -format "%c"]
    set quoi "classe \{$date_heure\} $duree" 
  } else {
    set quoi "classe \{Ddd Mmm 99 00:00:00 9999\} 0" 
  }

  enregistreval $titre $categorie $quoi $eleve

}

# #################################################################################
# frame en bas avec boutons 'continuer', flches gauche et droite, le score et une tiquette de controle de la rponse

frame .bframe -bg $glob(bgcolor)
pack .bframe -side bottom -expand true
label .bframe.lab2 -bg $glob(bgcolor) -font 12x24
grid .bframe.lab2 -column 1 -padx 20 -row 1

button .bframe.but_gauche -image \
	[image create photo fgauche -file [file join sysdata fgauche.gif]] \
	-command "recule; main $c"
grid .bframe.but_gauche -column 2 -row 1

label .bframe.lab3 -bg $glob(bgcolor) -font 12x24
grid .bframe.lab3 -column 5 -padx 20 -row 1

button .bframe.but_quitter -image \
	[image create photo fquitter -file [file join sysdata quitter_minus.gif]] \
	-command exit 
grid .bframe.but_quitter -column 6  -row 1

# ##############################################################################
# Dans un tableau de nc_piste colonnes et nr_piste lignes, 
# la piste est constitu de certaines cases lues dans un fichier
# ##############################################################################
proc max { a b } {
  if { $a > $b } {
    return $a
  } else {
    return $b
  }
}

proc avance {} {
  global glob
  set tmp [expr $glob(difficulte_piste) + 1 ]
  if [catch {set tmp_liste [glob pistes/$tmp.*]} resultat ] {
    # en cas d'erreur, on ne change pas la difficult
  } else {
    if { [llength $tmp_liste ] > 0 } {
      set glob(difficulte_piste) $tmp
    }
  }
}

proc recule {} {
  global glob
  set tmp [expr $glob(difficulte_piste) - 1 ]
  if [catch {set tmp_liste [glob pistes/$tmp.*]} resultat ] {
    # en cas d'erreur, on ne change pas la difficult
  } else {
    if { [llength $tmp_liste ] > 0 } {
      set glob(difficulte_piste) $tmp
    }
  }
}

proc extreme_case { c i } {
  global glob case
  if { $glob(sens) == 9 } {
    if { $case($i) == 1 } {
    # on va entrer en piste
     . configure -cursor target 
      set glob(precedent_piste) $i
      $c delete case($i)
      set case($i) 0
      if { $i == $glob(first_piste) } {
        set glob(sens) 1
      } else {
        set glob(sens) -1
      }
    } else {
      # rien (sinon erreur de code ?)
    }
  } else {
    if { $case($i) == 1 } {
      # on est dj en piste : c'est l'autre bout !
      # vrifier la case prcdente (fonction du sens !)
      set actuel [lsearch $glob(cases_piste) $i]
      set precedent [lsearch $glob(cases_piste) $glob(precedent_piste)]
      if { $glob(sens) == [expr $actuel - $precedent] } {
        # c'est bon, on continue
        # tout effacer
        # toutes les cases sont initialement vides
        for { set k 0 } { $k < [expr $glob(nr_piste) * $glob(nc_piste)] } { incr k } {
          $c delete case($k)
        }
        sauver_trace_parcours
        .bframe.but_gauche configure -state disable
        .bframe.lab2 configure -text "                   " 
        . configure -cursor left_ptr
        after [expr $glob(attente) * 1000] {
          set glob(session_finie) non
        }
        vwait glob(session_finie)

        if { $glob(session_finie) == "non" } {
          avance
          main $c
        } else {
          exit
        }

      } else {
        # on n'est pas/plus en piste
      }
    } else {
      # rien (sinon erreur de code ?)
    }
  }
} ;# proc extreme_case

proc enterCase { c i } {
  global glob case
  if { $glob(sens) != 9 && $case($i) == 2 } {
  # on est en piste, vrifier la case prcdente (fonction du sens !)
    set actuel [lsearch $glob(cases_piste) $i]
    set precedent [lsearch $glob(cases_piste) $glob(precedent_piste)]
    if { $glob(sens) == [expr $actuel - $precedent] } {
      # c'est bon, on continue
      set glob(precedent_piste) $i
      $c delete case($i)      
      set case($i) 0
    } else {
    # on n'est pas/plus en piste
    }
  }
} ;# proc enterCase

proc vider_case { c i } {
  global glob case
  set i_row [expr int($i / $glob(nc_piste))]
  set i_col [expr $i % $glob(nc_piste)]
  $c create rect \
	[expr $glob(org)+$i_col*$glob(width_case)+1] [expr $glob(org)+$i_row*$glob(width_case)+1] \
	[expr $glob(org)+($i_col+1)*$glob(width_case)+1] [expr $glob(org)+($i_row+1)*$glob(width_case)+1] \
	-fill $glob(bgcolor) -width 0 -tag case($i)
  set case($i) 9
}

proc remplir_case { c i } {
  global glob case
  set i_row [expr int($i / $glob(nc_piste))]
  set i_col [expr $i % $glob(nc_piste)]
  if { $i == $glob(first_piste) || $i == $glob(last_piste) } {
    $c create rect \
	[expr $glob(org)+$i_col*$glob(width_case)+1] [expr $glob(org)+$i_row*$glob(width_case)+1] \
	[expr $glob(org)+($i_col+1)*$glob(width_case)+1] [expr $glob(org)+($i_row+1)*$glob(width_case)+1] \
	-fill red -width 1 -tag case($i)
    $c bind case($glob(first_piste)) <Button-1> "extreme_case $c $glob(first_piste)"
    $c bind case($glob(last_piste)) <Button-1> "extreme_case $c $glob(last_piste)"
    set case($i) 1 ;#extrmit
  } else {
    $c create rect \
	[expr $glob(org)+$i_col*$glob(width_case)+1] [expr $glob(org)+$i_row*$glob(width_case)+1] \
	[expr $glob(org)+($i_col+1)*$glob(width_case)+1] [expr $glob(org)+($i_row+1)*$glob(width_case)+1] \
	-fill green -width 1 -tag case($i)
    $c bind case($i) <Enter> "enterCase $c $i"
    set case($i) 2 ;#non extrmit
  }
} ;# remplir_case

proc init_piste { c nom } {
  global glob limages case

 # afficher le fond
  # pour cela choisir au hasard une image de la liste limages

# AMODIFIER

  set rlimages [expr int(rand()*[llength $limages])]
  set bgimg [lindex $limages $rlimages]

# FIN AMODIFIER

  set bgimage [image create photo -file $bgimg]
  set hbgimage [image height $bgimage]
  set wbgimage [image width $bgimage]

  set glob(width_case) [max \
	[expr int($wbgimage/$glob(nc_piste))] \
	[expr int($hbgimage/$glob(nr_piste))] ] 

  $c create image \
	[expr $glob(org) + int($wbgimage/2)+1] [expr $glob(org) + int($hbgimage/2)+1] -image $bgimage

  ####################Cration du tableau###################################
  # On utilise des rectangles pour dessiner les cases
  # L'avantage des rectangles, c'est qu'ils peuvent constituer des objets
  # indpendants, utile si on veut leur associer des comportements

  # toutes les cases sont initialement vides
  for { set i 0 } { $i < [expr $glob(nr_piste) * $glob(nc_piste)] } { incr i } {
    vider_case $c $i
  } 

  # lire la liste des cases  remplir
  set f [ open [ file join $nom] "r"]
  set glob(cases_piste) [gets $f]
  close $f 

  # maintenant les cases de la piste
  # les extrmits de la piste
  set glob(first_piste) [lindex $glob(cases_piste) 0]
  set glob(last_piste) [lindex $glob(cases_piste) [expr [llength $glob(cases_piste)] - 1]]
  # remplir les cases de la piste
  foreach i $glob(cases_piste) {
    remplir_case $c $i
  } 
  # sens de parcours, dans la piste
  set glob(sens) 9 ;# sens de parcours 1=direct -1=indirect 9=undef

} ;# proc init_piste



# ####################### proc main ########################
proc main {c} {
  global glob heure_debut

  $c delete all

  .bframe.lab2 configure -text [mc {parcourir}] 
  grid .bframe.lab2 -padx 20 
  .bframe.but_gauche configure -state normal

  wm title . "[mc {title_m}]"

  set liste_pistes [glob pistes/$glob(difficulte_piste).*]
  set r [expr int(rand()*[llength $liste_pistes])]
  init_piste $c [lindex $liste_pistes $r]

  if { $glob(platform) == "unix" } {
    set heure_debut [clock clicks -milliseconds]
  } else {
    set heure_debut 0
  }
} ;# proc main

#####################################Gestion des vnements############################

bind . <Destroy> exit

##################################################################"

  # Relire le nom rgl de l'utilisateur sous windows
  if {$glob(platform) == "windows"} {
    catch {set f [open [file join $glob(home_mulot) reglages trace_user] "r"]}
    gets $f glob(trace_user)
    close $f
  }

# appel de la procdure principale
set glob(difficulte_piste) 0
main $c
